#ifndef _COMMAND_NXT_
#define _COMMAND_NXT_

#include <NXT++.h>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>

using namespace std;

class cCommandNXT
{
	private:
		
		int Str2Int (const string &str);
		string Int2Str(int n);
		bool Str2Bool (const string &str);
		string ToLowerCase(string str);
		string Escape(string str);
		
		string RedirectCmd(vector<string>& cmds);

		string MotorCmd(vector<string>& cmds);
		string SensorCmd(vector<string>& cmds);
		string NXTCmd(vector<string>& cmds);

		bool CheckOutPort(const string& port);
		bool CheckInPort(const string& port);
		bool CheckPower(const string& power);
		bool CheckBoolean(const string& boolen);
		bool CheckTacho(const string& tacho); // TODO

		int ConvertPortOut(const string& port);
		int ConvertPortIn(const string& port);

		bool isOpen;
		bool shortReply;
		
	public:

		cCommandNXT();
		~cCommandNXT();
		string CallCmd(string& obj);
		void EnableShortReply();
		
};
#endif
