#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <ctime>
#include <iostream>
#include <vector>
#include <boost/asio.hpp>

#include "../include/CommandNXT.h"

#define MSG_LEN 512

using boost::asio::ip::tcp;

int main()
{
  try
  {
    boost::asio::io_service io_service;

    tcp::acceptor acceptor(io_service, tcp::endpoint(tcp::v4(), 2056));
	tcp::socket socket(io_service);
    acceptor.accept(socket);

	cCommandNXT* obj = new cCommandNXT;
	boost::system::error_code ignored_error;

	// in loop taking a commands and do work for client on NXT
    for (;;)
    {
		boost::system::error_code error;
		boost::array<char, 512> response;


		std::size_t s = socket.read_some(boost::asio::buffer(response), error);

		std::string res(response.data(), s);

		for(int i = 0; i < res.length(); ++i)
		{
			if(res[i] == 13 || res[i] == 10)
				res.erase(i);

			else if(res[i] == 39 || res[i] == 34)
				res[i] = ' ';			
		}

		cout << res << endl;

		if(res == "shortrep" || res == " shortrep ")
		{
			obj->EnableShortReply();
		}

		else if(res == "bye" || res == " bye ")
			return 0;

		else if(!res.empty())
		{
			std::string result = obj->CallCmd(res);

			if(result != "-1-")
			{
				result += '\n';
			
				boost::asio::write(socket, boost::asio::buffer(result),
				boost::asio::transfer_all(), ignored_error);
			}
		}
    }
  }
  catch (std::exception& e)
  {
    std::cerr << e.what() << std::endl;
  }

  return 0;
}
